package com.measureModel.units.memory;

import java.math.BigDecimal;

import com.measureModel.arithmeticObjects.ArithmeticObject;
import com.measureModel.units.UnitBehavior;

/**
 * This class models a Small Integer. 
 * 
 * @author jressia
 *
 */
public class NaturalNumber {
	
	private Float number;
	
	// Class Methods -------------------------------------
	private NaturalNumber() {
	}
	
	public NaturalNumber(Float aFloat) {
		number = aFloat;
	}
	
	public NaturalNumber(float aFloat) {
		number = new Float(aFloat);
	}
	
	public NaturalNumber(double aDouble) {
		number = new Float(aDouble);
	}
	// Instance Methods ----------------------------------

	public int hashCode() {
		return number.hashCode();
	}

	public String toString() {
		return number.toString();
	}


	public float floatValue() {
		ComplexNumber aNumber = new ComplexNumber(2);
		aNumber.asComplexNumber();
		return number.floatValue();
	}
		
	public boolean isZero() {
		return number.floatValue() == 0;
	}
	
	public boolean isOne() {
		return number.floatValue() == 1;
	}
	
	public boolean equalsFloatNumber(NaturalNumber aFloatNumber) {
		return number.equals(aFloatNumber.number);
	}	

	public NaturalNumber asFloatNumber() {
		return this; 
	}

	public boolean isNegative() {
		return number.floatValue() < 0;
	}

	public boolean isPositive() {
		return number.floatValue() > 0;
	}
	
	public void asNaturalNumber(Float aFloat) {
		number = aFloat;
	}
	


}
